package xamora.gp_dbc.system;

import JinRyuu.JRMCore.JRMCoreH;
import JinRyuu.JRMCore.server.JGPlayerMP;
import com.forgeessentials.chat.ModuleChat;
import xamora.gp_dbc.Main;
import xamora.gp_dbc.utils.Pos;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.nbt.NBTTagCompound;
import xamora.gp_dbc.config.ConfigManager;

import java.util.HashMap;
import java.util.List;
import java.util.UUID;

import static xamora.gp_dbc.config.ConfigManager.*;

public class Criminal {

    private String name;
    private UUID uuid;
    private long rate;
    private long last_time_pos;
    private Pos last_pos;

    public HashMap<UUID, Integer> victims_alignLoose = new HashMap<>();

    public Criminal(EntityPlayer player) {
        this(player, 0);
    }

    public Criminal(EntityPlayer player, long rate) {
        this(player.getUniqueID(), ConfigManager.NICKNAME_FOR_CRIMINAL ? ModuleChat.getPlayerNickname(player) : player.getDisplayName(), rate, null);
    }

    public Criminal(UUID uuid, String name, long rate, Pos pos) {
        this(uuid, name, rate, 0, pos);
    }

    public Criminal(UUID uuid, String name, long rate, long last_time_pos, Pos pos) {
        this.uuid = uuid;
        setRate(rate);
        this.name = name;
        this.last_time_pos = last_time_pos;
        this.last_pos = pos;
    }

    public void addKill(EntityPlayer killed) {
        JGPlayerMP jgKilled = new JGPlayerMP(killed);
        jgKilled.connectBaseNBT();
        int add = Math.max(jgKilled.getAlignment() - 33, 0);
        if (Main.gp.isInGalacticPatrol(killed))
            add *= 2;
        rate += add;

        victims_alignLoose.put(killed.getUniqueID(), add);
    }

    public boolean cancelVictim(UUID killed) {
        if (!victims_alignLoose.containsKey(killed))
            return false;

        int align = victims_alignLoose.get(killed);
        rate -= align;
        victims_alignLoose.remove(killed);

        return true;
    }

    // Jail in second
    public long getTimeJail() {
        return (long) (rate * MULT_JAIL_TIME);
    }

    public Pos getLastPos() {
        return last_pos;
    }

    public long getLastPosTime() {
        return last_time_pos;
    }

    public UUID getUuid() {
        return uuid;
    }
    public String getName() { return name; }
    public long getRate() { return rate; }

    public void setRate(long rate) {
        this.rate = Math.min(rate, ConfigManager.MAX_RATE_CRIMINAL);
    }

    public void setPos(Pos pos) {
        this.last_time_pos = System.currentTimeMillis();
        this.last_pos = pos;
    }


    @Override
    public String toString() {
        if (last_pos != null) {
            return uuid + "$" + name + "$" + rate + "$" + last_time_pos + "$" + last_pos.x + "@" + last_pos.y + "@" + last_pos.z + "@" + last_pos.dimension + "@" + last_pos.dimension_name;
        }
        else
            return uuid + "$" + name + "$" + rate + "$" + last_time_pos;
    }

    public String toStringWithoutPos() {
        return uuid + "$" + name + "$" + rate + "$" + last_time_pos;
    }
}
