package xamora.gp_dbc.utils;

import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.server.MinecraftServer;
import net.minecraft.util.MathHelper;
import net.minecraft.world.Teleporter;
import net.minecraft.world.WorldServer;

public class TeleportUtils extends Teleporter
{

    private final WorldServer worldServerInstance;

    public TeleportUtils(WorldServer par1WorldServer) {
        super(par1WorldServer);
        this.worldServerInstance = par1WorldServer;
    }

    @Override
    public void placeInPortal(Entity entity, double p2, double p3, double p4, float p5) {
        int i = MathHelper.floor_double(entity.posX);
        int j = MathHelper.floor_double(entity.posY);
        int k = MathHelper.floor_double(entity.posZ);

        this.worldServerInstance.getBlock(i, j, k); //dummy load to maybe gen chunk
        int height = this.worldServerInstance.getHeightValue(i, k);
        entity.setPosition( i, height, k );
        return;

    } // dont do ANY portal junk, just grab a dummy block then SHOVE the player setPosition() at height

    public static void teleportDimension(EntityPlayer player, double x, double y, double z, int dimension) {
        MinecraftServer ms = MinecraftServer.getServer();
        WorldServer ws = ms.worldServerForDimension(dimension);
        Teleporter teleporter = new TeleportUtils(ws);
        ms.getConfigurationManager().transferPlayerToDimension((EntityPlayerMP) player, dimension, teleporter);
        player.setPositionAndUpdate(x + 0.5, y, z + 0.5);
    }

}